/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.uniffle.shuffle.manager;

import org.junit.jupiter.api.Test;

import org.apache.uniffle.common.config.RssBaseConf;
import org.apache.uniffle.common.rpc.ServerType;

import static org.junit.jupiter.api.Assertions.assertThrows;

public class ShuffleManagerServerFactoryTest {
  @Test
  public void testShuffleManagerServerType() {
    // add code to generate tests that check the server type
    RssBaseConf conf = new RssBaseConf();
    conf.set(RssBaseConf.RPC_SERVER_TYPE, ServerType.GRPC);
    ShuffleManagerServerFactory factory = new ShuffleManagerServerFactory(null, conf);
    // this should execute normally;
    factory.getServer();

    // other types should raise an exception
    conf.set(RssBaseConf.RPC_SERVER_TYPE, ServerType.GRPC_NETTY);
    factory = new ShuffleManagerServerFactory(null, conf);
    assertThrows(UnsupportedOperationException.class, factory::getServer);
  }
}
